{
  "openapi": "3.0.4",
  "info": {
    "title": "Akur8 Life API",
    "version": "1.0"
  },
  "paths": {
    "/api/v1/Arrays/{arrayId}": {
      "get": {
        "tags": [
          "Arrays"
        ],
        "summary": "Get detailed information about a specific array including all values and type-specific properties.",
        "description": "This endpoint returns array details with properties varying based on the array type:\n            \n- **Static Arrays**: Returns a list of string values in order\n- **Product Output Grouping Arrays**: Returns the product output grouping ID\n- **Calculated Range Arrays**: Returns start/end/step value configurations (variable, constant, or time index)\n- **Data Table Arrays**: Returns the data table variable name and calculation level\n- **Multi-Dimensional Arrays**: Returns the IDs of both dimension arrays\n            \nThis endpoint can be used with:\n- Production models (using a Workspace or Personal token)\n- Workspace models (using a Workspace or Personal token)\n            \nThe user must have appropriate permissions to access the model containing the array.",
        "operationId": "GetArrayDetails",
        "parameters": [
          {
            "name": "arrayId",
            "in": "path",
            "description": "The unique identifier of the array to retrieve.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the array to retrieve",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetArrayDetailsResponse"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Arrays": {
      "post": {
        "tags": [
          "Arrays"
        ],
        "summary": "Create a new static array with the provided values.",
        "description": "This endpoint creates a new array on the specified model.\n            \nOnly the \"Static\" array source is supported at this time. Providing any other array source returns an error.\n            \nThe array name must be unique within the model and can be up to 128 characters.\nAll values must be unique and non-empty. Each value can be up to 200 characters.\nThe values are saved in the order they are provided.\n            \nThis endpoint cannot be used with production or library models.",
        "operationId": "CreateStaticArray",
        "requestBody": {
          "description": "The request containing the model ID, array name, array source, and values.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateStaticArrayRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateStaticArrayRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateStaticArrayRequestV1"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateStaticArrayResponseV1"
                }
              }
            }
          },
          "400": {
            "description": "Invalid request parameters or the model does not exist",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "403": {
            "description": "The user cannot edit the model, or the model is a library model",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "409": {
            "description": "An array already exists on the model with the provided name",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Arrays/{ArrayId}/Values": {
      "put": {
        "tags": [
          "Arrays"
        ],
        "summary": "Update the values in a static array.",
        "description": "This endpoint can be used to replace all existing values in a static array.\n            \nAll values must be unique and non-empty. Each value can be up to 200 characters.",
        "operationId": "UpdateStaticArrayValues",
        "parameters": [
          {
            "name": "ArrayId",
            "in": "path",
            "description": "The ID of the static array to update.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the static array to update",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "description": "The request containing the new array values.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateStaticArrayValuesRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateStaticArrayValuesRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateStaticArrayValuesRequestV1"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UpdateStaticArrayValuesResponseV1"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "404": {
            "description": "Not Found",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Authorize": {
      "post": {
        "tags": [
          "Authorize"
        ],
        "summary": "Required for getting the API token which is needed to access the other endpoints.",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AuthorizeParametersV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/AuthorizeParametersV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/AuthorizeParametersV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiTokenDto"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          }
        }
      }
    },
    "/api/v1/Authorize/Refresh": {
      "post": {
        "tags": [
          "Authorize"
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RefreshParametersV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/RefreshParametersV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/RefreshParametersV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiTokenDto"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          }
        }
      }
    },
    "/api/v2/DataTables": {
      "post": {
        "tags": [
          "DataTables"
        ],
        "summary": "Creates a new data table without a file using row data provided in the request.",
        "description": "Creates a new data table using row data provided directly in the request body.\n\n**Limits:**\n- Minimum: 1 row\n- Maximum: 100,000 rows\n- Request size: 10MB\n\n**Row Format:**\nEach row is an array of strings where values are **positional** - each position corresponds to a column in table structure order. Use empty string `\"\"` for null/empty values at any position.\n\n**Example 1:** For columns [Name (String), Age (Integer), Rate (Decimal)]:\n- `[\"John\", \"25\", \"0.05\"]` - all values\n- `[\"John\", \"\", \"0.05\"]` - Age is empty\n- `[\"\", \"25\", \"\"]` - Name and Rate are empty\n\n**Example 2:** For columns [Name (String), Scenario (ScenarioTable), Active (Boolean)]:\n- `[\"Base\", \"15\", \"true\"]` - references ScenarioTable ID 15\n- `[\"Alt\", \"\", \"true\"]` - no ScenarioTable reference (empty string)\n\n**Example 3:** For columns [Name (String), Mortality (MortalityTable), Nested (DataTable)]:\n- `[\"Row1\", \"16757\", \"499\", \"42\"]` - MortalityTable uses 2 positions, DataTable uses 1\n- `[\"Row2\", \"\", \"\", \"\"]` - all reference columns empty\n\n**Supported Column Types:**\n| Type | Values | Example |\n|------|--------|--------|\n| Integer (1) | 1 value | \"100\" |\n| Decimal (2) | 1 value | \"0.0123\" |\n| String (3) | 1 value | \"Male\" |\n| Date (4) | 1 value | \"2024-01-15\" |\n| Boolean (5) | 1 value | \"true\" or \"false\" |\n| MortalityTable (6) | **2 values** | \"16757\", \"499\" |\n| DataTable (7) | 1 value | \"42\" or \"\" |\n| DropDownList (8) | 1 value | \"Option1\" |\n| ScenarioTable (9) | 1 value | \"15\" or \"\" |\n\n**Important:**\n- MortalityTable columns expand to **2 positions** in the row array (decrementTableId, improvementScaleId)\n- All other column types use **1 position** each\n- Row length must equal: (column count) + (number of MortalityTable columns)\n- Invalid DataTable/ScenarioTable reference IDs are silently cleared to empty\n- Format matches GET /api/v1/DataTables/{id}/Data response",
        "operationId": "CreateDataTableV2",
        "requestBody": {
          "description": "Create request containing table structure, name, and row data",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDataTableRequestV2"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDataTableRequestV2"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDataTableRequestV2"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Data table created successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ImportDataTableResponseV2"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Invalid request parameters or validation errors"
          },
          "403": {
            "description": "Forbidden - insufficient permissions"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Table structure not found"
          },
          "401": {
            "description": "Unauthorized"
          },
          "409": {
            "description": "Data table with the same name already exists for this table structure"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v2/DataTables/Import": {
      "post": {
        "tags": [
          "DataTables"
        ],
        "summary": "Creates a new data table from an imported file.",
        "description": "Creates a new data table using an existing file. This endpoint cannot be used to update existing data tables. The excel sheet name field is required for excel files and the delimiter field, which defaults to a comma if not set, is required for non-excel files. The limit for the number of rows is 25,000 for data tables that aren't file only.",
        "operationId": "ImportDataTable",
        "requestBody": {
          "description": "Import request containing table structure, name, and file reference",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ImportDataTableRequestV2"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/ImportDataTableRequestV2"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/ImportDataTableRequestV2"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Data table created successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ImportDataTableResponseV2"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Invalid request parameters"
          },
          "403": {
            "description": "Forbidden - insufficient permissions"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          },
          "409": {
            "description": "Data table with the same name already exists for this table structure"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v2/DataTables/{dataTableId}/Import": {
      "put": {
        "tags": [
          "DataTables"
        ],
        "summary": "Overwrites an existing data table from an imported file.",
        "description": "Overwrites the contents of an existing data table using the specified file. Library and Production models cannot be updated using this endpoint. The excel sheet name field is required for excel files and the delimiter field, which defaults to a comma if not set, is required for non-excel files. The limit for the number of rows is 25,000 for data tables that aren't file only.",
        "operationId": "OverwriteDataTable",
        "parameters": [
          {
            "name": "dataTableId",
            "in": "path",
            "description": "The ID of the data table to overwrite",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "description": "Import request containing file reference",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/OverwriteDataTableRequestV2"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/OverwriteDataTableRequestV2"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/OverwriteDataTableRequestV2"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Data table overwritten successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ImportDataTableResponseV2"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Invalid request parameters or Library/Production model"
          },
          "403": {
            "description": "Forbidden - insufficient permissions"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Data table not found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v2/DataTables/{dataTableId}": {
      "patch": {
        "tags": [
          "DataTables"
        ],
        "summary": "Updates individual properties of an existing data table.",
        "description": "This endpoint cannot be used on production models. Only development models can be updated.\nIf the data table indexes are being updated and the table is used in any projections, a new version will be created automatically to preserve projection integrity.\nName-only updates do not trigger versioning.",
        "operationId": "UpdateDataTableProperties",
        "parameters": [
          {
            "name": "dataTableId",
            "in": "path",
            "description": "The ID of the data table to update",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "description": "Update request containing optional Name and/or Indexes",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV2"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV2"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV2"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Data table updated successfully",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UpdateDataTableResponseV2"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Invalid request parameters or no properties provided"
          },
          "403": {
            "description": "Forbidden - cannot update production models or insufficient permissions"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Data table not found"
          },
          "401": {
            "description": "Unauthorized"
          },
          "409": {
            "description": "Data table with the same name already exists for this table structure"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/DataTables/Data": {
      "get": {
        "tags": [
          "DataTables"
        ],
        "summary": "Get a data table's data.",
        "description": "Either the data table ID must be provided, or the data table's name along with its associated table structure ID must be provided. <br/>If the data table is file only, then a file path to the file along with the file version will be returned so that it can be used with the GetDownloadUrl endpoint. <br/>For other data tables the rows are returned in the response up to the limit. The default limit is 2,000 and the max limit is 10,000. <br/>If the row limit is reached, then an offset is returned that can be used in a subsequent request to get the next set of rows. <br/>The response includes the TableStructureId of the table structure the data table is a part of, even when the requested data table is not the latest version.",
        "operationId": "GetDataTableData",
        "parameters": [
          {
            "name": "DataTableId",
            "in": "query",
            "description": "Data Table ID",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Name",
            "in": "query",
            "description": "Data Table Name",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Version",
            "in": "query",
            "description": "Data Table Version",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "TableStructureId",
            "in": "query",
            "description": "Table Structure ID",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetDataTableResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/DataTables": {
      "patch": {
        "tags": [
          "DataTables"
        ],
        "summary": "Update a data table using an existing file.",
        "description": "This endpoint has the same limitations mentioned in the create data table POST endpoint. <br/>In addition, be aware that a successful request might cause the table to be versioned, thus returning a new data table id that represents the versioned table. <br/>A table will be versioned if it's been used in a projection since the last time it was modified.",
        "operationId": "UpdateDataTable",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateOrUpdateDataTableResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/DataTables/{DataTableId}/Data": {
      "put": {
        "tags": [
          "DataTables"
        ],
        "summary": "Update a data table's row data without uploading a file.",
        "description": "Pass row data directly to update the data table without needing to upload a file first. Rows should be formatted as arrays of string values matching the column order from the GET /Data endpoint. Index columns come first (sorted by SortOrder), then data columns (sorted by SortOrder). For MortalityTable columns, pass two values: DecrementTableId and ImprovementScaleId. Maximum of 100,000 rows. Note: There is also a 10MB request size limit. A successful request might cause the table to be versioned if it has been used in a projection since the last modification.",
        "operationId": "UpdateDataTableData",
        "parameters": [
          {
            "name": "DataTableId",
            "in": "path",
            "description": "The ID of the data table to update.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Data Table Id",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "description": "The row data to replace existing data.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableDataRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableDataRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateDataTableDataRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Data table data updated successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UpdateDataTableDataResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Invalid request (file-only table, validation errors, row limit exceeded)."
          },
          "403": {
            "description": "Cannot update data tables on production models or no model access."
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Data table not found."
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/DecrementTables/{DecrementTableId}": {
      "get": {
        "tags": [
          "DecrementTables"
        ],
        "summary": "Get a decrement table.",
        "operationId": "GetDecrementTableById",
        "parameters": [
          {
            "name": "DecrementTableId",
            "in": "path",
            "description": "Decrement Table Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Decrement Table Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetDecrementTableResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      },
      "delete": {
        "tags": [
          "DecrementTables"
        ],
        "summary": "Delete a decrement table.",
        "operationId": "DeleteDecrementTableById",
        "parameters": [
          {
            "name": "DecrementTableId",
            "in": "path",
            "description": "Decrement Table Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Decrement Table Id",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK"
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/DecrementTables": {
      "post": {
        "tags": [
          "DecrementTables"
        ],
        "summary": "Create a decrement table using an existing file.",
        "operationId": "CreateDecrementTable",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDecrementTableRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDecrementTableRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateDecrementTableRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateOrUpdateDecrementTableResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          },
          "409": {
            "description": "Decrement table name already exists"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Files/GetFiles": {
      "get": {
        "tags": [
          "Files"
        ],
        "summary": "Get all currently available latest-version files.",
        "operationId": "GetFiles",
        "parameters": [
          {
            "name": "Folders",
            "in": "query",
            "description": "Optional parameter to filter files to specific folders. The list must be in CSV format. If folder contains a comma, make sure to surround it with double quotes. Example: folder1,folder2,\"folder,3\"",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetFilesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Files/GetDownloadUrl": {
      "post": {
        "tags": [
          "Files"
        ],
        "summary": "Get a temporary URL to download a file.",
        "operationId": "GetDownloadUrl",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/FilePathAndVersionDtoV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/FilePathAndVersionDtoV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/FilePathAndVersionDtoV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetDownloadUrlResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Files/GetUploadUrl": {
      "post": {
        "tags": [
          "Files"
        ],
        "summary": "Get a temporary URL to upload a file to a certain file path via a PUT request with the file data.",
        "description": "Passing in the ContentType and ContentMD5 values is optional. If provided, they will be included in the signature, but are not stored at this point. <br/><br/>Exclude the <i>'Content-Type'</i> header from the PUT request if this is not set. <br/>If included, the <i>'Content-Type'</i> header in the PUT request must match the provided ContentType value. <br/><br/>Exclude the <i>'ContentMD5'</i> header from the PUT request if this is not set. <br/>If included, the <i>'Content-MD5'</i> header in the PUT request must match the provided ContentMD5 value. <br/><br/><b>NOTE:</b> There is a 5GB limit on the size of the file.",
        "operationId": "GetUploadUrl",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GetUploadUrlFilePathDtoV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/GetUploadUrlFilePathDtoV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/GetUploadUrlFilePathDtoV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetUploadUrlResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Files/SaveUpload": {
      "post": {
        "tags": [
          "Files"
        ],
        "summary": "Save the file that was uploaded via the upload url returned by the GetUploadUrl endpoint.",
        "operationId": "SaveUpload",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SaveUploadFilePathDtoV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/SaveUploadFilePathDtoV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/SaveUploadFilePathDtoV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SaveUploadResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/ImprovementScales/{ImprovementScaleId}": {
      "get": {
        "tags": [
          "ImprovementScales"
        ],
        "summary": "Get an improvement scale.",
        "operationId": "GetImprovementScaleById",
        "parameters": [
          {
            "name": "ImprovementScaleId",
            "in": "path",
            "description": "Improvement Scale ID",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Improvement Scale ID",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetImprovementScaleResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/ImprovementScales": {
      "post": {
        "tags": [
          "ImprovementScales"
        ],
        "summary": "Create an improvement scale using an existing file.",
        "operationId": "CreateImprovementScale",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateImprovementScaleRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateImprovementScaleRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateImprovementScaleRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateOrUpdateImprovementScaleResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          },
          "409": {
            "description": "Improvement scale name already exists"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/ModelPointFields": {
      "post": {
        "tags": [
          "ModelPointFields"
        ],
        "summary": "Create a new model point field for a product.",
        "description": "This endpoint will:\n- Validate the user has permission to modify the model\n- Ensure the model is not in production\n- Validate field name and alias uniqueness\n- Validate data type rules (e.g., only Decimal fields can scale)\n- Trigger validation on dependent entities\n- Initiate async file validation\n\nField names and aliases must be unique within the product's model point file definition.\nOnly Decimal fields can be configured to scale on purchase or sale.",
        "operationId": "CreateModelPointField",
        "requestBody": {
          "description": "The model point field creation request.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateModelPointFieldRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateModelPointFieldRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateModelPointFieldRequestV1"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateModelPointFieldResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/ModelPointFields/{modelPointFieldId}": {
      "delete": {
        "tags": [
          "ModelPointFields"
        ],
        "summary": "Delete a model point field by its ID.",
        "description": "This endpoint will:\n- Validate the user has permission to modify the model\n- Ensure the model is not in production\n- Prevent deletion of system model point fields (e.g., Issue Date)\n- Trigger validation on dependent entities\n- Initiate async file validation\n\nOnly one model point field can be deleted at a time.",
        "operationId": "DeleteModelPointField",
        "parameters": [
          {
            "name": "modelPointFieldId",
            "in": "path",
            "description": "The ID of the model point field to delete.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the model point field to delete",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK"
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      },
      "patch": {
        "tags": [
          "ModelPointFields"
        ],
        "summary": "Update an existing model point field.",
        "description": "This endpoint will:\n- Validate the user has permission to modify the model\n- Ensure the model is not in production\n- Support partial updates (only send fields to be updated)\n- Validate field name and alias uniqueness\n- Enforce system field restrictions (cannot update DataType, IsRequired, or IsScaledOnPurchaseOrSale for system fields)\n- Validate data type rules (e.g., only Decimal fields can scale)\n- Prevent changing DataType to non-Decimal when IsScaledOnPurchaseOrSale is true\n- Trigger validation on model point files when critical properties change\n\nFor system model point fields, the Data Type, IsRequired flag, and Scales on Purchase or Sale flag cannot be updated.\nField names and aliases must remain unique within the product's model point file definition.",
        "operationId": "UpdateModelPointField",
        "parameters": [
          {
            "name": "modelPointFieldId",
            "in": "path",
            "description": "The ID of the model point field to update.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the model point field to update",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "description": "The model point field update request with partial update support.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateModelPointFieldRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateModelPointFieldRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateModelPointFieldRequestV1"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UpdateModelPointFieldResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get a paginated list of models by type (Library, Workspace, or Production).",
        "operationId": "ListModels",
        "parameters": [
          {
            "name": "ModelType",
            "in": "query",
            "description": "Type of models to retrieve: Library, Workspace, or Production",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ModelTypeFilter"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseListModelsResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/ProjectionTemplates": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's projection templates.",
        "operationId": "GetProjectionTemplatesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelProjectionTemplatesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/DataTables": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's data tables.",
        "operationId": "GetDataTablesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "TableStructureName",
            "in": "query",
            "description": "Optional Table Structure Name filter",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelDataTablesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/DecrementTables": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's decrement tables.",
        "operationId": "GetDecrementTablesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelDecrementTablesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/ScenarioTables": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's scenario tables.",
        "operationId": "GetScenarioTablesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelScenarioTablesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/ImprovementScales": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's improvement scales.",
        "operationId": "GetImprovementScalesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelImprovementScalesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/TableStructures": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's table structures.",
        "operationId": "GetTableStructuresByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelTableStructuresResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/InvestmentStrategies": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's investment strategies.",
        "operationId": "GetInvestmentStrategiesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelInvestmentStrategiesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/Products": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's products.",
        "operationId": "GetProductsByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelProductsResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/ProductOutputGroupings": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's product output groupings.",
        "description": "Library models are not supported and return a 403.",
        "operationId": "GetProductOutputGroupingsByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelProductOutputGroupingsResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/VariableRates": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's variable rates.",
        "operationId": "GetVariableRatesByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelVariableRatesResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/Copy": {
      "post": {
        "tags": [
          "Models"
        ],
        "summary": "Initiate an asynchronous copy of a model. Returns a token to check copy status.",
        "description": "Creates a full copy of the specified model. The copy is performed asynchronously in the background. Use the returned copy token to check the status of the copy operation. Note: Copy tokens are only valid for 24 hours after the copy is initiated. Library models cannot be copied in this version.",
        "operationId": "CopyModel",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "The ID of the model to copy",
            "required": true,
            "schema": {
              "maximum": 2147483647,
              "minimum": 1,
              "type": "integer",
              "description": "The ID of the model to copy",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CopyModelRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CopyModelRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CopyModelRequestV1"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CopyModelResponseV1"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Forbidden"
          },
          "404": {
            "description": "Not Found"
          },
          "200": {
            "description": "Success"
          },
          "201": {
            "description": "Created"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/CopyStatus/{Token}": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Check the status of an asynchronous model copy operation.",
        "description": "Returns the current status of a model copy operation initiated via the Copy endpoint. The status can be Running, Completed, or Failed. When completed, the response includes the ID of the newly created model. When failed, the response includes an error message. Note: Copy tokens are only valid for 24 hours.",
        "operationId": "GetModelCopyStatus",
        "parameters": [
          {
            "name": "Token",
            "in": "path",
            "description": "The copy token returned from the Copy endpoint",
            "required": true,
            "schema": {
              "type": "string",
              "description": "The copy token returned from the Copy endpoint"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ModelCopyStatusResponseV1"
                }
              }
            }
          },
          "404": {
            "description": "Not Found",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Models/{ModelId}/Arrays": {
      "get": {
        "tags": [
          "Models"
        ],
        "summary": "Get model's arrays.",
        "operationId": "GetArraysByModelId",
        "parameters": [
          {
            "name": "ModelId",
            "in": "path",
            "description": "Model Id",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Model Id",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelArraysResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Products/{ProductId}/ModelPointFields": {
      "get": {
        "tags": [
          "Products"
        ],
        "summary": "Get all model point fields for a product.",
        "description": "This endpoint will:\n- Validate the user has permission to view the model\n- Return all model point fields for the specified product\n- Support pagination with offset and limit\n- Support field filtering via the Fields parameter\n- Include Field Name, Field ID, Description, Data Type, IsRequired flag, Scales flags, Default values, and Aliases",
        "operationId": "GetModelPointFields",
        "parameters": [
          {
            "name": "ProductId",
            "in": "path",
            "description": "The ID of the product to get model point fields for.",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "The ID of the product to get model point fields for",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelPointFieldsResponseItemV1"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelPointFieldsResponseItemV1"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseGetModelPointFieldsResponseItemV1"
                }
              }
            }
          },
          "404": {
            "description": "Not Found",
            "content": {
              "text/plain": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              },
              "text/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProblemDetails"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Projections": {
      "get": {
        "tags": [
          "Projections"
        ],
        "summary": "Get a paginated list of projections in the workspace.",
        "description": "Returns projections accessible to the current user. Workspace API tokens see all projections; Personal API tokens only see projections for models the user has access to.",
        "operationId": "ListProjections",
        "parameters": [
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. \nThe list must be in CSV format. Example: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "Limit",
            "in": "query",
            "description": "Optional parameter to limit the number of items returned. Default is 200.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "Offset",
            "in": "query",
            "description": "Optional parameter to offset the items returned. Default is 0.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaginatedResponseListProjectionsResponseItemV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      },
      "post": {
        "tags": [
          "Projections"
        ],
        "summary": "Create a projection using an existing projection template.",
        "operationId": "CreateProjectionFromTemplate",
        "parameters": [
          {
            "name": "TemplateId",
            "in": "query",
            "description": "Template ID",
            "schema": {
              "type": "integer",
              "description": "Template ID",
              "format": "int32"
            }
          },
          {
            "name": "Name",
            "in": "query",
            "description": "Projection Name",
            "schema": {
              "type": "string",
              "description": "Projection Name"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateProjectionFromTemplateRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateProjectionFromTemplateRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateProjectionFromTemplateRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/CreateProjectionFromTemplateResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      }
    },
    "/api/v1/Projections/{projectionId}": {
      "get": {
        "tags": [
          "Projections"
        ],
        "summary": "Get Projection Details by Id.",
        "operationId": "GetProjectionById",
        "parameters": [
          {
            "name": "projectionId",
            "in": "path",
            "description": "Projection ID",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Projection ID",
              "format": "int32"
            }
          },
          {
            "name": "Fields",
            "in": "query",
            "description": "Optional parameter to filter the top-level fields that are returned. The list must be in CSV format.\nExample: field1,field2,field3",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetProjectionResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
            "description": "Too Many Requests"
          },
          "404": {
            "description": "Not Found"
          },
          "401": {
            "description": "Unauthorized"
          }
        },
        "security": [
          {
            "API Token": [ ]
          }
        ]
      },
      "patch": {
        "tags": [
          "Projections"
        ],
        "summary": "Update projection properties.",
        "description": "Validating model point files is limited to 100K rows with 20 columns.<br/><b>For larger model point files set ValidateModelPointFiles to false.</b>",
        "operationId": "UpdateExistingProjection",
        "parameters": [
          {
            "name": "projectionId",
            "in": "path",
            "description": "Projection ID",
            "required": true,
            "schema": {
              "type": "integer",
              "description": "Projection ID",
              "format": "int32"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateProjectionRequestV1"
              }
            },
            "text/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateProjectionRequestV1"
              }
            },
            "application/*+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateProjectionRequestV1"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GetProjectionResponseV1"
                }
              }
            }
          },
          "201": {
            "description": "Created"
          },
          "400": {
            "description": "Bad Request"
          },
          "403": {
            "description": "Not Allowed To Access"
          },
          "429": {
[...]
